<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\String\StringHelper;

/**
 * @package		Joomla.Administrator
 * @subpackage	com_categories
 */
class RseventsproTableCategory extends JTableCategory
{
	/**
	 * Method to delete a node and, optionally, its child nodes from the table.
	 *
	 * @param   integer  $pk        The primary key of the node to delete.
	 * @param   boolean  $children  True to delete child nodes, false to move them up a level.
	 *
	 * @return  boolean  True on success.
	 *
	 * @see     http://docs.joomla.org/JTableNested/delete
	 * @since   2.5
	 */
	public function delete($pk = null, $children = true) {
		$delete = parent::delete($pk, $children);
		
		if ($delete) RSEventsProTranslations::removeTranslations('category', $pk);
		
		return $delete;
	}
	
	/**
	 * Overloaded check function
	 *
	 * @return	boolean
	 * @see		JTable::check
	 * @since	1.5
	 */
	public function check() {
		parent::check();
		
		if (!empty($this->id)) {
			RSEventsProTranslations::saveTranslations($this, 'category', RSEventsProTranslations::getLanguage('category', $this->id));
		}
		
		$table = JTable::getInstance('Category', 'RseventsproTable');
		
		while ($table->load(array('alias' => $this->alias, 'parent_id' => $this->parent_id, 'extension' => $this->extension))) {
			$this->alias = StringHelper::increment($this->alias, 'dash');
		}
		
		return true;
	}
}