<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class RseventsproTableTag extends JTable
{
	/**
	 * @param	JDatabase	A database connector object
	 */
	public function __construct($db) {
		parent::__construct('#__rseventspro_tags', 'id', $db);
	}
	
	/**
	 * Overloaded check function
	 *
	 * @return	boolean
	 * @see		JTable::check
	 * @since	1.5
	 */
	public function check() {
		if (empty($this->id)) {
			$this->language = JFactory::getLanguage()->getTag();
		} else {
			RSEventsProTranslations::saveTranslations($this, 'tag', RSEventsProTranslations::getLanguage('tag', $this->id));
		}
		
		return true;
	}
	
	/**
	 * Overrides JTable::store to set modified data and user id.
	 *
	 * @param   boolean  $updateNulls  True to update fields even if they are null.
	 *
	 * @return  boolean  True on success.
	 *
	 * @since   11.1
	 */
	public function store($updateNulls = false) {
		// Verify that the alias is unique
		$table = JTable::getInstance('Tag', 'RseventsproTable');
		if ($table->load(array('name' => $this->name)) && ($table->id != $this->id || $this->id == 0))
		{
			$this->setError(JText::_('COM_RSEVENTSPRO_DUPLICATE_TAG_NAME'));
			return false;
		}
		return parent::store($updateNulls);
	}
	
	public function delete($pk = null, $children = true) {
		$delete = parent::delete($pk, $children);
		
		if ($delete) RSEventsProTranslations::removeTranslations('tag', $pk);
		
		return $delete;
	}
}