<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class RseventsproTableTicket extends JTable
{	
	/**
	 * @param	JDatabase	A database connector object
	 */
	public function __construct($db) {
		parent::__construct('#__rseventspro_tickets', 'id', $db);
	}
	
	/**
	 * Method to perform sanity checks on the JTable instance properties to ensure
	 * they are safe to store in the database.  Child classes should override this
	 * method to make sure the data they are storing in the database is safe and
	 * as expected before storage.
	 *
	 * @return  boolean  True if the instance is sane and able to be stored in the database.
	 *
	 * @link    http://docs.joomla.org/JTable/check
	 * @since   11.1
	 */
	public function check() {
		$nulldate	= JFactory::getDbo()->getNullDate();
		$tzoffset	= JFactory::getConfig()->get('offset');
		
		if ($this->seats == JText::_('COM_RSEVENTSPRO_GLOBAL_UNLIMITED'))
			$this->seats = 0;
		if ($this->user_seats == JText::_('COM_RSEVENTSPRO_GLOBAL_UNLIMITED'))
			$this->user_seats = 0;
		if (isset($this->groups) && is_array($this->groups)) {
			try {
				$registry = new JRegistry;
				$registry->loadArray($this->groups);
				$this->groups = $registry->toString();
			} catch (Exception $e) {}
		} else $this->groups = '';
		
		$this->from = !empty($this->from) && $this->from != $nulldate ? JFactory::getDate($this->from, $tzoffset)->toSql() : $nulldate;
		$this->to = !empty($this->to) && $this->to != $nulldate ? JFactory::getDate($this->to, $tzoffset)->toSql() : $nulldate;
		
		if (empty($this->seats)) $this->seats = 0;
		if (empty($this->user_seats)) $this->user_seats = 0;
		
		$lang = JFactory::getApplication()->isClient('site') ? JFactory::getLanguage()->getTag() : RSEventsProTranslations::getLanguage('event', $this->ide);
		RSEventsProTranslations::saveTranslations($this, 'ticket', $lang);
		
		return true;
	}
}