<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

abstract class modRseventsProLocation {

	public static function getLocation() {
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$id		= JFactory::getApplication()->input->getInt('id',0);
		$id		= is_array($id) ? $id[0] : $id;
		
		$query->clear()
			->select($db->qn('l.id'))->select($db->qn('l.name'))->select($db->qn('l.url'))
			->select($db->qn('l.address'))->select($db->qn('l.coordinates'))
			->from($db->qn('#__rseventspro_locations','l'))
			->join('left', $db->qn('#__rseventspro_events','e').' ON '.$db->qn('e.location').' = '.$db->qn('l.id'))
			->where($db->qn('e.id').' = '.$id)
			->where($db->qn('l.published').' = 1');
		
		$db->setQuery($query);
		return $db->loadObject();
	}
	
	public static function getMap($params, $coordinates) {
		$config		= rseventsproHelper::getConfig();
		$api		= $config->google_map_api;
		$width		= (int) $params->get('width',190);
		$height		= (int) $params->get('height',170);
		$zoom		= (int) $params->get('zoom',10);
		
		if (empty($coordinates)) {
			return false;
		}
		
		if ($config->map) {
			if ($config->map == 'google') {
				return 'https://maps.google.com/maps/api/staticmap?zoom='.$zoom.'&size='.$width.'x'.$height.'&markers='.$coordinates.($api ? '&key='.$api : '');
			} elseif ($config->map == 'openstreetmapbox') {
				list($lat, $lng) = explode(',', $coordinates, 2);
				$coordinates = $lng.','.$lat;
				return 'https://api.mapbox.com/styles/v1/mapbox/streets-v11/static/pin-l('.$coordinates.')/'.$coordinates.','.$zoom.',20/'.$width.'x'.$height.'?access_token='.$config->openstreet_mapbox_access_token;
			} elseif ($config->map == 'openstreetthunderforest') {
				return 'https://tile.thunderforest.com/static/neighbourhood/'.$coordinates.','.$zoom.'/'.$width.'x'.$height.'.png?apikey='.$config->openstreet_thunderforest_api_key;
			}
		}
		
		return false;
	}
}