<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2016 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

abstract class modRseventsProTickets {

	public static function getTickets() {
		$db		 = JFactory::getDbo();
		$query	 = $db->getQuery(true);
		$id		 = JFactory::getApplication()->input->getInt('id', 0);
		$id		= is_array($id) ? $id[0] : $id;
		$tickets = rseventsproHelper::getTickets($id, true);
		$w8list	 = rseventsproHelper::validWaitingList($id);
		$return	 = array();
		
		$query->clear()
			->select($db->qn('registration'))
			->from($db->qn('#__rseventspro_events'))
			->where($db->qn('id').' = '.$db->q($id));
		$db->setQuery($query);
		$registration = (int) $db->loadResult();
		
		if (!$registration) {
			return false;
		}
		
		if (!empty($tickets)) {
			foreach ($tickets as $ticket) {				
				if (!$w8list) {
					$checkticket = rseventsproHelper::checkticket($ticket->id);
					if ($checkticket == -1) {
						continue;
					}
				}
				
				$query->clear()
					->select('SUM('.$db->qn('quantity').')')
					->from($db->qn('#__rseventspro_user_tickets'))
					->where($db->qn('idt').' = '.(int) $ticket->id);
				
				$db->setQuery($query);
				$purchased = $db->loadResult();
				
				if ($ticket->seats > 0) {
					$disabled = 0;
					if ($ticket->disabled && $ticket->disabled_available) {
						for($i=1;$i<=$ticket->seats;$i++) {
							$modulo = $ticket->disabled == 1 ? 0 : 2;
							$is_disabled = ($i+1)%($ticket->disabled + 1);
							if ($is_disabled != $modulo) $disabled++;
						}
					}
					
					$available = $ticket->seats - $purchased - $disabled;
					if ($available > 0) {
						if ($ticket->price > 0) {
							$return[] = $available. ' x '.$ticket->name.' ('.rseventsproHelper::currency($ticket->price).')';
						} else {
							$return[] = $available. ' x '.$ticket->name.' ('.JText::_('COM_RSEVENTSPRO_GLOBAL_FREE').')';
						}
					}
				} else {
					if ($ticket->price > 0) {
						$return[] = JText::_('COM_RSEVENTSPRO_GLOBAL_UNLIMITED'). ' '.$ticket->name.' ('.rseventsproHelper::currency($ticket->price).')';
					} else {
						$return[] = JText::_('COM_RSEVENTSPRO_GLOBAL_UNLIMITED'). ' '.$ticket->name.' ('.JText::_('COM_RSEVENTSPRO_GLOBAL_FREE').')';
					}
				}
			}
		}
		
		return $return;
	}
	
	public static function getEvent() {
		$db		 = JFactory::getDbo();
		$query	 = $db->getQuery(true);
		$id		 = JFactory::getApplication()->input->getInt('id', 0);
		$id		 = is_array($id) ? $id[0] : $id;
		
		$query->clear()
			->select($db->qn('max_tickets'))->select($db->qn('max_tickets_amount'))
			->from($db->qn('#__rseventspro_events'))
			->where($db->qn('id').' = '.$db->q($id));
		$db->setQuery($query);
		return $db->loadObject();
	}
}