<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

abstract class modRseventsProMap {

	public static function getEvents($params) {
		$return		= array();
		
		if (file_exists(JPATH_SITE.'/components/com_rseventspro/helpers/query.php')) {
			require_once JPATH_SITE.'/components/com_rseventspro/helpers/query.php';
			
			$db		= JFactory::getDbo();
			$user	= JFactory::getUser();
			$full	= (int) $params->get('full',1);
			$query	= RSEventsProQuery::getInstance($params);
			$select = array('e.id', 'e.name', 'e.start', 'e.owner', 'e.end', 'e.allday', 'l.id' => 'lid', 'l.name' => 'lname', 'l.address', 'l.coordinates', 'l.marker');
			$group	= array('e.id', 'e.name', 'e.start', 'e.owner', 'e.end', 'e.allday', 'l.id', 'l.name', 'l.address', 'l.coordinates', 'l.marker');
			$query->select($select);
			$query->group($group);
			$query->featured(false);
			$query->userevents(false);
			
			$query = $query->toString();
			$db->setQuery($query);
			$events = $db->loadObjectList();
			
			if (!empty($events)) {
				foreach ($events as $event) {
					if (!rseventsproHelper::canview($event->id) && $event->owner != $user->get('id')) continue;
					if (!$full && rseventsproHelper::eventisfull($event->id)) continue; 
					$return[$event->lid][] = $event;
				}
			}
		}
		
		return $return;
	}
	
	public static function markers($locations, $itemid) {
		$markers = array(); 
		
		if ($locations) {
			foreach ($locations as $location => $events) {
				if (empty($events)) continue;
				$event = $events[0];
				if (empty($event->coordinates) && empty($event->address)) continue;
				$single = count($events) > 1 ? false : true;
				
				$marker = array(
					'title' => $event->name,
					'position' => $event->coordinates,
					'address' => $event->address,
					'content' => rseventsproHelper::locationContent($event, $single, $itemid)
				);
				
				if ($event->marker) { 
					$marker['icon'] = rseventsproHelper::showMarker($event->marker);
				}
				
				$markers[] = $marker;
			}
		}
		
		return $markers;
	}
	
	public static function escape($string) {
		return htmlentities($string,ENT_COMPAT,'UTF-8');
	}
}