<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

abstract class modRseventsProRelated {

	public static function getEvents($params) {
		$db			= JFactory::getDbo();
		$query		= $db->getQuery(true);
		$subquery	= $db->getQuery(true);
		$id			= JFactory::getApplication()->input->getInt('id', 0);
		$id			= is_array($id) ? $id[0] : $id;
		$categories	= (int) $params->get('categories',1);
		$locations	= (int) $params->get('locations',1);
		$tags		= (int) $params->get('tags',0);
		$speakers	= (int) $params->get('speakers',0);
		$sponsors	= (int) $params->get('sponsors',0);
		$order		= $params->get('ordering','start');
		$direction	= $params->get('order','DESC');
		$repeating	= (int) $params->get('repeating',0);
		$canceled	= (int) $params->get('canceled',1);
		$limit		= (int) $params->get('limit',4);
		$full		= (int) $params->get('full',1);
		$state		= $canceled ? ',3' : '';
		
		if ($id) {
			if ($categories) {
				$query->clear()
					->select($db->qn('id'))
					->from($db->qn('#__rseventspro_taxonomy'))
					->where($db->qn('type').' = '.$db->q('category'))
					->where($db->qn('ide').' = '.$db->q($id));
				$db->setQuery($query);
				$categories = $db->loadColumn();
			}
			
			if ($locations) {
				$query->clear()
					->select($db->qn('location'))
					->from($db->qn('#__rseventspro_events'))
					->where($db->qn('id').' = '.$db->q($id));
				$db->setQuery($query);
				$locations = $db->loadColumn();
			}
			
			if ($tags) {
				$query->clear()
					->select($db->qn('id'))
					->from($db->qn('#__rseventspro_taxonomy'))
					->where($db->qn('type').' = '.$db->q('tag'))
					->where($db->qn('ide').' = '.$db->q($id));
				$db->setQuery($query);
				$tags = $db->loadColumn();
			}
			
			if ($speakers) {
				$query->clear()
					->select($db->qn('id'))
					->from($db->qn('#__rseventspro_taxonomy'))
					->where($db->qn('type').' = '.$db->q('speaker'))
					->where($db->qn('ide').' = '.$db->q($id));
				$db->setQuery($query);
				$speakers = $db->loadColumn();
			}
			
			if ($sponsors) {
				$query->clear()
					->select($db->qn('id'))
					->from($db->qn('#__rseventspro_taxonomy'))
					->where($db->qn('type').' = '.$db->q('sponsor'))
					->where($db->qn('ide').' = '.$db->q($id));
				$db->setQuery($query);
				$sponsors = $db->loadColumn();
			}
		}
		
		$query->clear()
			->select($db->qn('e.id'))
			->from($db->qn('#__rseventspro_events','e'))
			->where($db->qn('e.completed').' = 1')
			->where($db->qn('e.published').' IN (1'.$state.')')
			->where($db->qn('e.id').' <> '.$db->q($id));
		
		if (!$repeating)
			$query->where($db->qn('e.parent').' = 0');
		
		if (is_array($categories) && !empty($categories)) {
			$categories = array_map('intval',$categories);
			
			$subquery->clear()
				->select($db->qn('tx.ide'))
				->from($db->qn('#__rseventspro_taxonomy','tx'))
				->join('left', $db->qn('#__categories','c').' ON '.$db->qn('c.id').' = '.$db->qn('tx.id'))
				->where($db->qn('c.id').' IN ('.implode(',',$categories).')')
				->where($db->qn('tx.type').' = '.$db->q('category'))
				->where($db->qn('c.extension').' = '.$db->q('com_rseventspro'));
			
			if (JLanguageMultilang::isEnabled()) {
				$subquery->where('c.language IN ('.$db->q(JFactory::getLanguage()->getTag()).','.$db->q('*').')');
			}
			
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$subquery->where('c.access IN ('.$groups.')');
			
			$query->where($db->qn('e.id').' IN ('.$subquery.')');
		}
		
		if (is_array($tags) && !empty($tags)) {
			$tags = array_map('intval',$tags);
			
			$subquery->clear()
				->select($db->qn('tx.ide'))
				->from($db->qn('#__rseventspro_taxonomy','tx'))
				->join('left', $db->qn('#__rseventspro_tags','t').' ON '.$db->qn('t.id').' = '.$db->qn('tx.id'))
				->where($db->qn('t.id').' IN ('.implode(',',$tags).')')
				->where($db->qn('tx.type').' = '.$db->q('tag'));
			
			$query->where($db->qn('e.id').' IN ('.$subquery.')');
		}
		
		if (is_array($locations) && !empty($locations)) {
			$locations = array_map('intval',$locations);
			
			$query->where($db->qn('e.location').' IN ('.implode(',',$locations).')');
		}
		
		if (is_array($speakers) && !empty($speakers)) {
			$speakers = array_map('intval',$speakers);
			
			$subquery->clear()
				->select($db->qn('tx.ide'))
				->from($db->qn('#__rseventspro_taxonomy','tx'))
				->join('left', $db->qn('#__rseventspro_speakers','s').' ON '.$db->qn('s.id').' = '.$db->qn('tx.id'))
				->where($db->qn('s.id').' IN ('.implode(',',$speakers).')')
				->where($db->qn('tx.type').' = '.$db->q('speaker'));
			
			$query->where($db->qn('e.id').' IN ('.$subquery.')');
		}
		
		if (is_array($sponsors) && !empty($sponsors)) {
			$sponsors = array_map('intval',$sponsors);
			
			$subquery->clear()
				->select($db->qn('tx.ide'))
				->from($db->qn('#__rseventspro_taxonomy','tx'))
				->join('left', $db->qn('#__rseventspro_sponsors','s').' ON '.$db->qn('s.id').' = '.$db->qn('tx.id'))
				->where($db->qn('s.id').' IN ('.implode(',',$sponsors).')')
				->where($db->qn('tx.type').' = '.$db->q('sponsor'));
			
			$query->where($db->qn('e.id').' IN ('.$subquery.')');
		}
		
		$exclude = modRseventsProRelated::excludeEvents();
		
		if (!empty($exclude))
			$query->where($db->qn('e.id').' NOT IN ('.implode(',',$exclude).')');
		
		$query->order($db->qn('e.'.$order).' '.$db->escape($direction));
		$query->order($db->qn('e.'.$order).' '.$db->escape($direction));
		
		if (!$full) {
			$db->setQuery($query);
			$events = $db->loadColumn();
			
			foreach ($events as $i => $event) {
				if (rseventsproHelper::eventisfull($event)) unset($events[$i]);
			}
			
			$events = array_slice($events, 0, $limit);
		} else {
			$db->setQuery($query,0,$limit);
			$events = $db->loadColumn();
		}
		
		return $events;
	}
	
	protected static function excludeEvents() {
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$user	= JFactory::getUser(); 
		$ids	= array();
		
		$query->clear()
			->select($db->qn('ide'))
			->from($db->qn('#__rseventspro_taxonomy'))
			->where($db->qn('type').' = '.$db->q('groups'));
		
		$db->setQuery($query);
		$eventids = $db->loadColumn();
		
		if (!empty($eventids)) {
			foreach ($eventids as $id) {
				$query->clear()
					->select($db->qn('owner'))
					->from($db->qn('#__rseventspro_events'))
					->where($db->qn('id').' = '.(int) $id);
				
				$db->setQuery($query);
				$owner = (int) $db->loadResult();
				
				if (!rseventsproHelper::canview($id) && $owner != $user->get('id'))
					$ids[] = $id;
			}
			
			if (!empty($ids)) {
				$ids = array_map('intval',$ids);
				$ids = array_unique($ids);
			}
		}
		
		return $ids;
	}
}