<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

if (file_exists(JPATH_SITE.'/components/com_rseventspro/helpers/rseventspro.php')) { 
	require_once JPATH_SITE.'/components/com_rseventspro/helpers/rseventspro.php';
	require_once JPATH_SITE.'/components/com_rseventspro/helpers/route.php';
	require_once JPATH_SITE.'/modules/mod_rseventspro_map/helper.php';
	
	// Load jQuery
	rseventsproHelper::loadjQuery();
	
	$config = rseventsproHelper::getConfig();
	
	// Load scripts
	JHtml::stylesheet('mod_rseventspro_map/style.css', array('relative' => true, 'version' => 'auto'));
	JFactory::getLanguage()->load('com_rseventspro');

	$events	= modRseventsProMap::getEvents($params);
	$width 	= $params->get('width', '100%');
	$height = $params->get('height', '250px');
	
	$mapParams = array(
		'id' => 'rs_canvas'.$module->id,
		'zoom' => (int) $config->google_map_zoom,
		'center' => $config->google_maps_center,
		'markerDraggable' => 'false',
		'markers' => modRseventsProMap::markers($events,$params->get('itemid'))
	);
	
	rseventsproMapHelper::loadMap($mapParams);
	
	if (strpos($width, '%') !== false) {
		$width = $width;
	} elseif (strpos($width, 'px') !== false) {
		$width = $width;
	} else {
		$width = (int) $width.'px';
	}
	
	if (strpos($height, '%') !== false) {
		$height = $height;
	} elseif (strpos($height, 'px') !== false) {
		$height = $height;
	} else {
		$height = (int) $height.'px';
	}
	
	require(JModuleHelper::getLayoutPath('mod_rseventspro_map'));	
}