<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); 
$count = count($this->data); ?>

<h1><?php echo JText::sprintf('COM_RSEVENTSPRO_SUBSCRIBERS_TICKETS',$this->row->name); ?></h1>

<script type="text/javascript">
function rs_clear() {
	jQuery('#searchstring').val('');
	jQuery('#ticket').val('-');
	document.adminForm.submit();
}
</script>

<form method="post" action="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&layout=subscriberstickets&id='.rseventsproHelper::sef($this->row->id,$this->row->name)); ?>" name="adminForm" id="adminForm">
	<div class="<?php echo RSEventsproAdapterGrid::row(); ?> mb-3">
		<div class="<?php echo RSEventsproAdapterGrid::column(6); ?>">
			<?php echo RSEventsproAdapterGrid::inputGroup('<input type="text" name="search" id="searchstring" onchange="adminForm.submit();" value="'.$this->filter_word.'" class="form-control" />', null, '<button type="button" class="btn btn-primary hasTooltip" title="'.JText::_('COM_RSEVENTSPRO_GLOBAL_SEARCH').'" onclick="adminForm.submit();"><i class="fa fa-search"></i></button> <button type="button" class="btn btn-danger hasTooltip" title="'.JText::_('COM_RSEVENTSPRO_GLOBAL_CLEAR').'" onclick="rs_clear();"><i class="fa fa-times"></i></button>'); ?>
		</div>
		<div class="<?php echo RSEventsproAdapterGrid::column(6); ?> text-right">
			<?php echo $this->lists['tickets']; ?>
		</div>
	</div>
	
	<?php if ($count) { ?>
	<div class="table-responsive">
		<table class="table table-striped">
			<thead>
				<tr>
					<th><?php echo JText::_('COM_RSEVENTSPRO_SUBSCRIBER_NAME'); ?></th>
					<th><?php echo JText::_('COM_RSEVENTSPRO_SUBSCRIBER_TICKET'); ?></th>
					<th><?php echo JText::_('COM_RSEVENTSPRO_SUBSCRIBER_TICKET_PDF_CODE'); ?></th>
					<th class="<?php echo RSEventsproAdapterGrid::styles(array('center')); ?>"><?php echo JText::_('COM_RSEVENTSPRO_SUBSCRIBER_TICKET_PDF_CONFIRMED'); ?></th>
				</tr>
			</thead>
			<tbody id="subscribersTicketsTable">
				<?php foreach ($this->data as $subscriber) { ?>
				<?php for($i=1;$i<=$subscriber->quantity;$i++) { ?>
				<?php $code	= md5($subscriber->id.$subscriber->tid.$i); ?>
				<?php $code	= substr($code,0,4).substr($code,-4); ?>
				<?php $code	= rseventsproHelper::getBarcodeOptions('barcode_prefix', 'RST-').$subscriber->id.'-'.$code; ?>
				<?php $code	= in_array(rseventsproHelper::getBarcodeOptions('barcode', 'C39'), array('C39', 'C93')) ? strtoupper($code) : $code; ?>
				<?php if ($this->ticket_search && $code != $this->filter_word) continue; ?>
				<?php $confirmed = rseventsproHelper::confirmed($subscriber->id, $code); ?>
				<tr>
					<td>
						<i class="fa fa-user"></i> <?php echo $subscriber->name; ?> <br>
						<i class="fa fa-calendar"></i> <?php echo rseventsproHelper::showdate($subscriber->date,null,true); ?>
					</td>
					<td><?php echo $subscriber->ticketname; ?></td>
					<td><?php echo $code; ?></td>
					<td class="<?php echo RSEventsproAdapterGrid::styles(array('center')); ?>">
						<span>
							<?php if ($confirmed) { ?>
							<a href="javascript:void(0)" class="label label-success <?php echo rseventsproHelper::tooltipClass(); ?>" title="<?php echo JText::_('COM_RSEVENTSPRO_UNCONFIRM_TICKET'); ?>" onclick="rsepro_confirm('<?php echo $code; ?>', 0, this, '<?php echo $this->row->id; ?>');"><?php echo JText::_('JYES'); ?></a>
							<?php } else { ?>
							<a href="javascript:void(0)" class="label <?php echo rseventsproHelper::tooltipClass(); ?>" title="<?php echo JText::_('COM_RSEVENTSPRO_CONFIRM_TICKET'); ?>" onclick="rsepro_confirm('<?php echo $code; ?>', 1, this, '<?php echo $this->row->id; ?>')"><?php echo JText::_('JNO'); ?></a>
							<?php } ?>
						</span>
					</td>
				</tr>
				<?php } ?>
				<?php } ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="4" class="<?php echo RSEventsproAdapterGrid::styles(array('center')); ?>"><?php echo $this->pagination->getListFooter(); ?></td>
				</tr>
			</tfoot>
		</table>
	</div>
	<?php } else { ?>
	<div class="alert alert-info"><?php echo JText::_('COM_RSEVENTSPRO_NO_SUBSCRIBERS_TICKETS'); ?></div>
	<?php } ?>
	
	<div class="form-actions">
		<a class="btn btn-info" href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&layout=show&id='.rseventsproHelper::sef($this->row->id,$this->row->name),false,rseventsproHelper::itemid($this->row->id)); ?>"><?php echo JText::_('COM_RSEVENTSPRO_GLOBAL_BACK'); ?></a>	
	</div>
	
	<span id="Itemid" class="rs_hidden"><?php echo JFactory::getApplication()->input->getInt('Itemid'); ?></span>
	
	<?php echo JHTML::_( 'form.token' ); ?>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="option" value="com_rseventspro" />
	<input type="hidden" name="view" value="rseventspro" />
</form>