<?php
/**
* @package RSEvents!Pro
* @copyright (C) 2020 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); ?>

<script type="text/javascript">
	function resetDisabledValue() {
		document.getElementById('resetDisabled').value = '1';
		Joomla.submitform('rseventspro.saveticketoptions');
	}
	
	function showSeats(el) {
		if (jQuery(el).val() == '1') {
			jQuery('#rsepro-manual-seats').css('display', '');
		} else {
			jQuery('#rsepro-manual-seats').css('display', 'none');
		}
	}
</script>

<form action="<?php echo JRoute::_('index.php?option=com_rseventspro', true); ?>" method="POST" id="adminForm" name="adminForm" class="form-horizontal">
	<div class="container">
		<?php if ($this->tickets) { ?><div class="alert alert-danger"><?php echo JText::_('COM_RSEVENTSPRO_TICKET_OPTIONS_ERROR'); ?></div><?php } ?>
		
		<div class="<?php echo RSEventsproAdapterGrid::row(); ?>">
			<div class="<?php echo RSEventsproAdapterGrid::column(12); ?>">
				<?php echo $this->form->renderField('start'); ?>
				<?php echo $this->form->renderField('disabled_type'); ?>
				<?php echo $this->form->renderField('available'); ?>
				<?php echo $this->form->renderField('disabled'); ?>
				<?php echo $this->form->renderField('disabled_available'); ?>
				
				<div id="rsepro-manual-seats" class="control-group" style="display:none">
					<div class="control-label"></div>
					<?php $style = empty($this->item->position) ? 'top: 10px; left: 10px; width: 90px;' : rseventsproHelper::parseStyle($this->item->position); ?>
					<div class="controls">
						<div class="alert alert-info"><?php echo JText::_('COM_RSEVENTSPRO_TICKET_DISABLED_TYPE_MANUAL_INFO'); ?></div>
						<div class="draggable-edit ui-widget-content" style="<?php echo $style; ?>cursor:default;">
							<div class="rsepro_ticket_container">
								<div class="rsepro_ticket_name">
									<?php echo $this->item->name; ?> - <?php echo $this->item->price ? rseventsproHelper::currency($this->item->price) : JText::_('COM_RSEVENTSPRO_GLOBAL_FREE'); ?>
								</div>			
							</div>
							<div class="rsepro_ticket_seats">
								<?php $start	= empty($this->item->start) ? 1 : $this->item->start; ?>
								<?php $end		= $start == 1 ? $this->item->seats : ($this->item->seats + $start - 1); ?>
								<?php for ($i=$start; $i <= $end; $i++) { ?>
								<div id="rsepro_seat_<?php echo $i; ?>" class="rsepro_ticket_seat<?php echo in_array($i, $this->item->manual_disabled) ? ' rsepro_disabled' : ''; ?>">
									<?php if (!$this->tickets) { ?><a href="javascript:void(0);" onclick="rsepro_disable_seat('<?php echo $i; ?>');"><?php } ?>
										<?php echo $i; ?>
									<?php if (!$this->tickets) { ?></a><?php } ?>
								</div>								
								<?php } ?>
							</div>
						</div>
					</div>
				</div>
				
				<?php if ($this->tickets && $this->form->getValue('disabled')) { ?>
				<?php $reset = ' <button class="btn btn-danger hasTooltip" title="'.JText::_('COM_RSEVENTSPRO_RESET_DISABLED_SEATS_DESC').'" type="button" onclick="resetDisabledValue()">'.JText::_('COM_RSEVENTSPRO_RESET_DISABLED_SEATS').'</button>'; ?>
				<?php } else $reset = ''; ?>
				<?php echo RSEventsproAdapterGrid::renderField('', '<button class="btn btn-primary" type="button" onclick="Joomla.submitform(\'rseventspro.saveticketoptions\')">'.JText::_('COM_RSEVENTSPRO_GLOBAL_SAVE').'</button> <button class="btn btn-danger" type="button" onclick="window.parent.jQuery.colorbox.close();">'.JText::_('COM_RSEVENTSPRO_GLOBAL_CANCEL').'</button>'.$reset); ?>
			</div>
		</div>
	</div>
	
	<div id="disabled_seats_container">
		<?php if ($this->item->manual_disabled) { ?>
		<?php foreach ($this->item->manual_disabled as $seat) { ?>
		<input type="hidden" id="disabled_seat_<?php echo $seat; ?>" name="jform[manual_disabled][]" value="<?php echo $seat; ?>">
		<?php } ?>
		<?php } ?>
	</div>
	<input type="hidden" name="task" value="rseventspro.saveticketoptions" />
	<input type="hidden" name="jform[reset]" value="0" id="resetDisabled" />
	<?php echo $this->form->getInput('id'); ?>
</form>
<script type="text/javascript">showSeats(document.getElementById('jform_disabled_type'));</script>