/**
 * @license
 * =========================================================
 * bootstrap-datetimepicker.js
 * http://www.eyecon.ro/bootstrap-datepicker
 * https://tarruda.github.io/bootstrap-datetimepicker/
 * =========================================================
 * Copyright 2012 Stefan Petre
 *
 * Contributions:
 *  - Andrew Rowls
 *  - Thiago de Arruda
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =========================================================
 */
!function(t){function e(t){return t.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")}function i(t,e,i){return e<t.length?t:Array(e-t.length+1).join(i||" ")+t}function s(){return new Date(Date.UTC.apply(Date,arguments))}window.orientation;var a=function(t,e){this.id=n++,this.init(t,e)};a.prototype={constructor:a,init:function(e,i){var s;if(!i.pickTime&&!i.pickDate)throw new Error("Must choose at least one picker");if(this.options=i,this.$element=t(e),this.language=i.language in o?i.language:"en",this.pickDate=i.pickDate,this.pickTime=i.pickTime,this.isInput=this.$element.is("input"),this.component=!1,(this.$element.find(".input-append")||this.$element.find(".input-prepend"))&&(this.component=this.$element.find("button:first")),this.format=i.format,this.reset=this.$element.find("button .icon-remove").parent(),this.onchangeFnct=this.options.onChangeFnct,this.collapseShow=3==this.$element.data("joomlaversion")?"in":"show",this.calendarTableClass=3==this.$element.data("joomlaversion")?"table-condensed":"table-sm",this.linkField=i.linkField,this.format||(this.isInput?this.format=this.$element.data("format"):this.format=this.$element.find("input").data("format"),this.format||(this.format="MM/dd/yyyy")),this._compileFormat(),this.component&&(s=this.component.find("i")),this.pickTime&&(s&&s.length&&(this.timeIcon=s.data("time-icon")),this.timeIcon||(this.timeIcon="icon-clock"),s.addClass(this.timeIcon)),this.pickDate&&(s&&s.length&&(this.dateIcon=s.data("date-icon")),this.dateIcon||(this.dateIcon="icon-calendar"),s.removeClass(this.timeIcon),s.addClass(this.dateIcon)),this.widget=t(function(t,e,i,s,a,n,o,r){return e&&i?'<div class="bootstrap-datetimepicker-widget dropdown-menu"><ul><li'+(n?' class="collapse '+o+'"':"")+'><div class="datepicker">'+p.getTemplate(r)+'</div></li><li class="picker-switch accordion-toggle"><a><i class="'+t+'"></i></a></li><li'+(n?' class="collapse"':"")+'><div class="timepicker">'+u.getTemplate(s,a,r)+"</div></li></ul></div>":i?'<div class="bootstrap-datetimepicker-widget dropdown-menu"><div class="timepicker">'+u.getTemplate(s,a,r)+"</div></div>":'<div class="bootstrap-datetimepicker-widget dropdown-menu"><div class="datepicker">'+p.getTemplate(r)+"</div></div>"}(this.timeIcon,i.pickDate,i.pickTime,i.pick12HourFormat,i.pickSeconds,i.collapse,this.collapseShow,this.calendarTableClass)).appendTo("body"),this.minViewMode=i.minViewMode||this.$element.data("date-minviewmode")||0,"string"==typeof this.minViewMode)switch(this.minViewMode){case"months":this.minViewMode=1;break;case"years":this.minViewMode=2;break;default:this.minViewMode=0}if(this.viewMode=i.viewMode||this.$element.data("date-viewmode")||0,"string"==typeof this.viewMode)switch(this.viewMode){case"months":this.viewMode=1;break;case"years":this.viewMode=2;break;default:this.viewMode=0}this.startViewMode=this.viewMode,this.weekStart=i.weekStart||this.$element.data("date-weekstart")||0,this.weekEnd=0===this.weekStart?6:this.weekStart-1,this.setStartDate(i.startDate||this.$element.data("date-startdate")),this.setEndDate(i.endDate||this.$element.data("date-enddate")),this.fillDow(),this.fillMonths(),this.fillHours(),this.fillMinutes(),this.fillSeconds(),this.update(),this.showMode(),this.attachDatePickerEvents()},show:function(t){this.widget.show(),this.height=this.component?this.component.outerHeight():this.$element.outerHeight(),this.place(),this.$element.trigger({type:"show",date:this._date}),this._attachDatePickerGlobalEvents(),t&&(t.stopPropagation(),t.preventDefault())},disable:function(){this.$element.find("input").prop("disabled",!0),this._detachDatePickerEvents()},enable:function(){this.$element.find("input").prop("disabled",!1),this.attachDatePickerEvents()},hide:function(){for(var t=this.widget.find(".collapse"),e=0;e<t.length;e++){var i=t.eq(e).data("collapse");if(i&&i.transitioning)return}this.widget.hide(),this.viewMode=this.startViewMode,this.showMode(),this.set(),this.$element.trigger({type:"hide",date:this._date}),this._detachDatePickerGlobalEvents()},set:function(){var e="";if(this._unset||(e=this.formatDate(this._date)),this.isInput)this.$element.val(e),this._resetMaskPos(this.$element);else{if(this.component){var i=this.$element.find("input");i.val(e),this._resetMaskPos(i)}this.$element.data("date",e)}this.linkField&&t("#"+this.linkField).val(this.formatDateToSql(this._date))},setValue:function(t){this._unset=!t,"string"==typeof t?this._date=this.parseDate(t):t&&(this._date=new Date(t)),this.set(),this.viewDate=s(this._date.getUTCFullYear(),this._date.getUTCMonth(),1,0,0,0,0),this.fillDate(),this.fillTime()},getDate:function(){return this._unset?null:new Date(this._date.valueOf())},setDate:function(t){t?this.setValue(t.valueOf()):this.setValue(null)},setStartDate:function(t){t instanceof Date?this.startDate=t:"string"==typeof t?(this.startDate=new s(t),this.startDate.getUTCFullYear()||(this.startDate=-1/0)):this.startDate=-1/0,this.viewDate&&this.update()},setEndDate:function(t){t instanceof Date?this.endDate=t:"string"==typeof t?(this.endDate=new s(t),this.endDate.getUTCFullYear()||(this.endDate=1/0)):this.endDate=1/0,this.viewDate&&this.update()},getLocalDate:function(){if(this._unset)return null;var t=this._date;return new Date(t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate(),t.getUTCHours(),t.getUTCMinutes(),t.getUTCSeconds(),t.getUTCMilliseconds())},setLocalDate:function(t){t?this.setValue(Date.UTC(t.getFullYear(),t.getMonth(),t.getDate(),t.getHours(),t.getMinutes(),t.getSeconds(),t.getMilliseconds())):this.setValue(null)},place:function(){var e="absolute",i=this.component?this.component.offset():this.$element.offset();this.width=this.component?this.component.outerWidth():this.$element.outerWidth(),i.top=i.top+this.height;var s=t(window);null!=this.options.width&&this.widget.width(this.options.width),"left"==this.options.orientation&&(this.widget.addClass("left-oriented"),i.left=i.left-this.widget.width()+20),this._isInFixed()&&(e="fixed",i.top-=s.scrollTop(),i.left-=s.scrollLeft()),s.width()<i.left+this.widget.outerWidth()?(i.right=s.width()-i.left-this.width,i.left="auto",this.widget.addClass("pull-right float-end")):(i.right="auto",this.widget.removeClass("pull-right float-end")),this.widget.css({position:e,top:i.top,left:i.left}),this.widget.attr("style",this.widget.attr("style")+"; right: "+i.right+("auto"==i.right?"":"px")+" !important")},notifyChange:function(){this.$element.trigger({type:"changeDate",date:this.getDate(),localDate:this.getLocalDate()}),"function"==typeof this.onchangeFnct&&this.onchangeFnct()},update:function(t){var e=t;if(!e&&((e=this.isInput?this.$element.val():this.$element.find("input").val())&&(this._date=this.parseDate(e)),!this._date)){var i=new Date;this._date=s(i.getFullYear(),i.getMonth(),i.getDate(),i.getHours(),i.getMinutes(),i.getSeconds(),i.getMilliseconds())}this.viewDate=s(this._date.getUTCFullYear(),this._date.getUTCMonth(),1,0,0,0,0),this.fillDate(),this.fillTime()},fillDow:function(){for(var e=this.weekStart,i=t("<tr>");e<this.weekStart+7;)i.append('<th class="dow">'+o[this.language].daysMin[e++%7]+"</th>");this.widget.find(".datepicker-days thead").append(i)},fillMonths:function(){for(var t="",e=0;e<12;)t+='<span class="month">'+o[this.language].monthsShort[e++]+"</span>";this.widget.find(".datepicker-months td").append(t)},fillDate:function(){var e=this.viewDate.getUTCFullYear(),i=this.viewDate.getUTCMonth(),a=s(this._date.getUTCFullYear(),this._date.getUTCMonth(),this._date.getUTCDate(),0,0,0,0),n="object"==typeof this.startDate?this.startDate.getUTCFullYear():-1/0,r="object"==typeof this.startDate?this.startDate.getUTCMonth():-1,h="object"==typeof this.endDate?this.endDate.getUTCFullYear():1/0,d="object"==typeof this.endDate?this.endDate.getUTCMonth():12;this.widget.find(".datepicker-days").find(".disabled").removeClass("disabled"),this.widget.find(".datepicker-months").find(".disabled").removeClass("disabled"),this.widget.find(".datepicker-years").find(".disabled").removeClass("disabled"),this.widget.find(".datepicker-days th:eq(1)").text(o[this.language].months[i]+" "+e);var c=s(e,i-1,28,0,0,0,0),l=p.getDaysInMonth(c.getUTCFullYear(),c.getUTCMonth());c.setUTCDate(l),c.setUTCDate(l-(c.getUTCDay()-this.weekStart+7)%7),(e==n&&i<=r||e<n)&&this.widget.find(".datepicker-days th:eq(0)").addClass("disabled"),(e==h&&i>=d||e>h)&&this.widget.find(".datepicker-days th:eq(2)").addClass("disabled");var u=new Date(c.valueOf());u.setUTCDate(u.getUTCDate()+42),u=u.valueOf();for(var f,m,g=[];c.valueOf()<u;)c.getUTCDay()===this.weekStart&&(f=t("<tr>"),g.push(f)),m="",c.getUTCFullYear()<e||c.getUTCFullYear()==e&&c.getUTCMonth()<i?m+=" old":(c.getUTCFullYear()>e||c.getUTCFullYear()==e&&c.getUTCMonth()>i)&&(m+=" new"),c.valueOf()===a.valueOf()&&(m+=" active"),c.valueOf()+864e5<=this.startDate&&(m+=" disabled"),c.valueOf()>this.endDate&&(m+=" disabled"),f.append('<td class="day'+m+'">'+c.getUTCDate()+"</td>"),c.setUTCDate(c.getUTCDate()+1);this.widget.find(".datepicker-days tbody").empty().append(g);var v=this._date.getUTCFullYear(),w=this.widget.find(".datepicker-months").find("th:eq(1)").text(e).end().find("span").removeClass("active");v===e&&w.eq(this._date.getUTCMonth()).addClass("active"),v-1<n&&this.widget.find(".datepicker-months th:eq(0)").addClass("disabled"),v+1>h&&this.widget.find(".datepicker-months th:eq(2)").addClass("disabled");for(var k=0;k<12;k++)e==n&&r>k||e<n?t(w[k]).addClass("disabled"):(e==h&&d<k||e>h)&&t(w[k]).addClass("disabled");g="",e=10*parseInt(e/10,10);var T=this.widget.find(".datepicker-years").find("th:eq(1)").text(e+"-"+(e+9)).end().find("td");for(this.widget.find(".datepicker-years").find("th").removeClass("disabled"),n>e&&this.widget.find(".datepicker-years").find("th:eq(0)").addClass("disabled"),h<e+9&&this.widget.find(".datepicker-years").find("th:eq(2)").addClass("disabled"),e-=1,k=-1;k<11;k++)g+='<span class="year'+(-1===k||10===k?" old":"")+(v===e?" active":"")+(e<n||e>h?" disabled":"")+'">'+e+"</span>",e+=1;T.html(g)},fillHours:function(){var t=this.widget.find(".timepicker .timepicker-hours table");t.parent().hide();var e="";if(this.options.pick12HourFormat)for(var s=1,a=0;a<3;a+=1){e+="<tr>";for(var n=0;n<4;n+=1)e+='<td class="hour">'+i(s.toString(),2,"0")+"</td>",s++;e+="</tr>"}else for(s=0,a=0;a<6;a+=1){for(e+="<tr>",n=0;n<4;n+=1)e+='<td class="hour">'+i(s.toString(),2,"0")+"</td>",s++;e+="</tr>"}t.html(e)},fillMinutes:function(){var t=this.widget.find(".timepicker .timepicker-minutes table");t.parent().hide();for(var e="",s=0,a=0;a<5;a++){e+="<tr>";for(var n=0;n<4;n+=1)e+='<td class="minute">'+i(s.toString(),2,"0")+"</td>",s+=3;e+="</tr>"}t.html(e)},fillSeconds:function(){var t=this.widget.find(".timepicker .timepicker-seconds table");t.parent().hide();for(var e="",s=0,a=0;a<5;a++){e+="<tr>";for(var n=0;n<4;n+=1)e+='<td class="second">'+i(s.toString(),2,"0")+"</td>",s+=3;e+="</tr>"}t.html(e)},fillTime:function(){if(this._date){var t=this.widget.find(".timepicker span[data-time-component]"),e=(t.closest("table"),this.options.pick12HourFormat),s=this._date.getUTCHours(),a="AM";e&&(s>=12&&(a="PM"),0===s?s=12:12!=s&&(s%=12),this.widget.find(".timepicker [data-action=togglePeriod]").text(a)),s=i(s.toString(),2,"0");var n=i(this._date.getUTCMinutes().toString(),2,"0"),o=i(this._date.getUTCSeconds().toString(),2,"0");t.filter("[data-time-component=hours]").text(s),t.filter("[data-time-component=minutes]").text(n),t.filter("[data-time-component=seconds]").text(o)}},click:function(e){e.stopPropagation(),e.preventDefault(),this._unset=!1;var i=t(e.target).closest("span, td, th");if(1===i.length&&!i.is(".disabled"))switch(i[0].nodeName.toLowerCase()){case"th":switch(i[0].className){case"switch":this.showMode(1);break;case"prev":case"next":var a=this.viewDate,n=p.modes[this.viewMode].navFnc,o=p.modes[this.viewMode].navStep;"prev"===i[0].className&&(o*=-1),a["set"+n](a["get"+n]()+o),this.fillDate(),this.set()}break;case"span":if(i.is(".month")){var r=i.parent().find("span").index(i);this.viewDate.setUTCMonth(r)}else{var h=parseInt(i.text(),10)||0;this.viewDate.setUTCFullYear(h)}0!==this.viewMode&&(this._date=s(this.viewDate.getUTCFullYear(),this.viewDate.getUTCMonth(),this.viewDate.getUTCDate(),this._date.getUTCHours(),this._date.getUTCMinutes(),this._date.getUTCSeconds(),this._date.getUTCMilliseconds()),this.notifyChange()),this.showMode(-1),this.fillDate(),this.set();break;case"td":if(i.is(".day")){var d=parseInt(i.text(),10)||1;r=this.viewDate.getUTCMonth(),h=this.viewDate.getUTCFullYear(),i.is(".old")?0===r?(r=11,h-=1):r-=1:i.is(".new")&&(11==r?(r=0,h+=1):r+=1),this._date=s(h,r,d,this._date.getUTCHours(),this._date.getUTCMinutes(),this._date.getUTCSeconds(),this._date.getUTCMilliseconds()),this.viewDate=s(h,r,Math.min(28,d),0,0,0,0),this.fillDate(),this.set(),this.notifyChange()}}},actions:{incrementHours:function(t){this._date.setUTCHours(this._date.getUTCHours()+1)},incrementMinutes:function(t){this._date.setUTCMinutes(this._date.getUTCMinutes()+1)},incrementSeconds:function(t){this._date.setUTCSeconds(this._date.getUTCSeconds()+1)},decrementHours:function(t){this._date.setUTCHours(this._date.getUTCHours()-1)},decrementMinutes:function(t){this._date.setUTCMinutes(this._date.getUTCMinutes()-1)},decrementSeconds:function(t){this._date.setUTCSeconds(this._date.getUTCSeconds()-1)},togglePeriod:function(t){var e=this._date.getUTCHours();e>=12?e-=12:e+=12,this._date.setUTCHours(e)},showPicker:function(){this.widget.find(".timepicker > div:not(.timepicker-picker)").hide(),this.widget.find(".timepicker .timepicker-picker").show()},showHours:function(){this.widget.find(".timepicker .timepicker-picker").hide(),this.widget.find(".timepicker .timepicker-hours").show()},showMinutes:function(){this.widget.find(".timepicker .timepicker-picker").hide(),this.widget.find(".timepicker .timepicker-minutes").show()},showSeconds:function(){this.widget.find(".timepicker .timepicker-picker").hide(),this.widget.find(".timepicker .timepicker-seconds").show()},selectHour:function(e){var i=t(e.target),s=parseInt(i.text(),10);this.options.pick12HourFormat&&(this._date.getUTCHours()>=12?12!=s&&(s=(s+12)%24):12===s?s=0:s%=12),this._date.setUTCHours(s),this.actions.showPicker.call(this)},selectMinute:function(e){var i=t(e.target),s=parseInt(i.text(),10);this._date.setUTCMinutes(s),this.actions.showPicker.call(this)},selectSecond:function(e){var i=t(e.target),s=parseInt(i.text(),10);this._date.setUTCSeconds(s),this.actions.showPicker.call(this)}},doAction:function(e){e.stopPropagation(),e.preventDefault(),this._date||(this._date=s(1970,0,0,0,0,0,0));var i=t(e.currentTarget).data("action"),a=this.actions[i].apply(this,arguments);return this.set(),this.fillTime(),this.notifyChange(),a},stopEvent:function(t){t.stopPropagation(),t.preventDefault()},keydown:function(e){var i=this,s=e.which,a=t(e.target);8!=s&&46!=s||setTimeout(function(){i._resetMaskPos(a)})},keypress:function(e){var i=e.which;if(8!=i&&46!=i){var s=t(e.target),a=String.fromCharCode(i),n=s.val()||"";n+=a;var o=this._mask[this._maskPos];if(!o)return!1;if(o.end==n.length){if(!o.pattern.test(n.slice(o.start))){for(n=n.slice(0,n.length-1);(o=this._mask[this._maskPos])&&o.character;)n+=o.character,this._maskPos++;return n+=a,o.end!=n.length?(s.val(n),!1):o.pattern.test(n.slice(o.start))?(s.val(n),this._maskPos++,!1):(s.val(n.slice(0,o.start)),!1)}this._maskPos++}}},change:function(e){var i=t(e.target),s=i.val();"today"==s?this.linkField&&t("#"+this.linkField).val(s):this._formatPattern.test(s)?(this.update(),this.setValue(this._date.getTime()),this.notifyChange(),this.set()):s&&s.trim()?(this.setValue(this._date.getTime()),this._date?this.set():i.val("")):this._date&&(this.setValue(null),this.notifyChange(),this._unset=!0),this._resetMaskPos(i)},showMode:function(t){t&&(this.viewMode=Math.max(this.minViewMode,Math.min(2,this.viewMode+t))),this.widget.find(".datepicker > div").hide().filter(".datepicker-"+p.modes[this.viewMode].clsName).show()},destroy:function(){this._detachDatePickerEvents(),this._detachDatePickerGlobalEvents(),this.widget.remove(),this.$element.removeData("datetimepicker"),this.component.removeData("datetimepicker")},formatDate:function(t){return this.format.replace(l,function(e){var s,a,n,o=e.length;if("ms"===e&&(o=1),"Hours12"===(a=r[e].property))0===(n=t.getUTCHours())?n=12:12!==n&&(n%=12);else{if("Period12"===a)return t.getUTCHours()>=12?"PM":"AM";n=t[s="get"+a]()}return"getUTCMonth"===s&&(n+=1),"getUTCYear"===s&&(n=n+1900-2e3),i(n.toString(),o,"0")})},formatDateToSql:function(t){return"yyyy-MM-dd hh:mm:ss".replace(l,function(e){var s,a,n,o=e.length;if("ms"===e&&(o=1),"Hours12"===(a=r[e].property))0===(n=t.getUTCHours())?n=12:12!==n&&(n%=12);else{if("Period12"===a)return t.getUTCHours()>=12?"PM":"AM";n=t[s="get"+a]()}return"getUTCMonth"===s&&(n+=1),"getUTCYear"===s&&(n=n+1900-2e3),i(n.toString(),o,"0")})},parseDate:function(t){var e,i,s,a,n={};if(!(e=this._formatPattern.exec(t)))return null;for(i=1;i<e.length;i++)(s=this._propertiesByIndex[i])&&(a=e[i],/^\d+$/.test(a)&&(a=parseInt(a,10)),n[s]=a);return this._finishParsingDate(n)},_resetMaskPos:function(t){for(var e=t.val(),i=0;i<this._mask.length;i++){if(this._mask[i].end>e.length){this._maskPos=i;break}if(this._mask[i].end===e.length){this._maskPos=i+1;break}}},_finishParsingDate:function(t){var e,i,a,n,o,r,h;return e=t.UTCFullYear,t.UTCYear&&(e=2e3+t.UTCYear),e||(e=1970),i=t.UTCMonth?t.UTCMonth-1:0,a=t.UTCDate||1,n=t.UTCHours||0,o=t.UTCMinutes||0,r=t.UTCSeconds||0,h=t.UTCMilliseconds||0,t.Hours12&&(n=t.Hours12),t.Period12&&(/pm/i.test(t.Period12)?12!=n&&(n=(n+12)%24):n%=12),s(e,i,a,n,o,r,h)},_compileFormat:function(){for(var t,i,s=[],a=[],n=this.format,o={},h=0,d=0;t=c.exec(n);)(i=t[0])in r?(o[++h]=r[i].property,s.push("\\s*"+r[i].getPattern(this)+"\\s*"),a.push({pattern:new RegExp(r[i].getPattern(this)),property:r[i].property,start:d,end:d+=i.length})):(s.push(e(i)),a.push({pattern:new RegExp(e(i)),character:i,start:d,end:++d})),n=n.slice(i.length);this._mask=a,this._maskPos=0,this._formatPattern=new RegExp("^\\s*"+s.join("")+"\\s*$"),this._propertiesByIndex=o},attachDatePickerEvents:function(){var e=this;if(this.widget.on("click",".datepicker *",t.proxy(this.click,this)),this.widget.on("click","[data-action]",t.proxy(this.doAction,this)),this.widget.on("mousedown",t.proxy(this.stopEvent,this)),this.pickDate&&this.pickTime&&this.widget.on("click.togglePicker",".accordion-toggle",function(i){i.stopPropagation();var s=t(this),a=s.closest("ul"),n=a.find(".collapse."+e.collapseShow),o=a.find(".collapse:not(."+e.collapseShow+")");if(n&&n.length){var r=n.data("collapse");if(r&&r.transitioning)return;n.collapse("hide"),o.collapse("show"),s.find("i").toggleClass(e.timeIcon+" "+e.dateIcon),e.$element.find("button i:first").toggleClass(e.timeIcon+" "+e.dateIcon)}}),this.isInput?(this.$element.on({focus:t.proxy(this.show,this),change:t.proxy(this.change,this)}),this.options.maskInput&&this.$element.on({keydown:t.proxy(this.keydown,this),keypress:t.proxy(this.keypress,this)})):(this.$element.on({change:t.proxy(this.change,this)},"input"),this.options.maskInput&&this.$element.on({keydown:t.proxy(this.keydown,this),keypress:t.proxy(this.keypress,this)},"input"),this.component?this.component.on("click",t.proxy(this.show,this)):this.$element.on("click",t.proxy(this.show,this))),this.reset){var i=this.linkField;this.reset.on("click",function(){i&&t("#"+i).val(""),e.$element.find("input").val(""),e.notifyChange()})}},_attachDatePickerGlobalEvents:function(){t(window).on("resize.datetimepicker"+this.id,t.proxy(this.place,this)),this.isInput||t(document).on("mousedown.datetimepicker"+this.id,t.proxy(this.hide,this))},_detachDatePickerEvents:function(){this.widget.off("click",".datepicker *",this.click),this.widget.off("click","[data-action]"),this.widget.off("mousedown",this.stopEvent),this.pickDate&&this.pickTime&&this.widget.off("click.togglePicker"),this.isInput?(this.$element.off({focus:this.show,change:this.change}),this.options.maskInput&&this.$element.off({keydown:this.keydown,keypress:this.keypress})):(this.$element.off({change:this.change},"input"),this.options.maskInput&&this.$element.off({keydown:this.keydown,keypress:this.keypress},"input"),this.component?this.component.off("click",this.show):this.$element.off("click",this.show))},_detachDatePickerGlobalEvents:function(){t(window).off("resize.datetimepicker"+this.id),this.isInput||t(document).off("mousedown.datetimepicker"+this.id)},_isInFixed:function(){if(this.$element){for(var e=this.$element.parents(),i=!1,s=0;s<e.length;s++)if("fixed"==t(e[s]).css("position")){i=!0;break}return i}return!1}},t.fn.datetimepicker=function(e,i){return this.each(function(){var s=t(this),n=s.data("datetimepicker"),o="object"==typeof e&&e;n||s.data("datetimepicker",n=new a(this,t.extend({},t.fn.datetimepicker.defaults,o))),"string"==typeof e&&n[e](i)})},t.fn.datetimepicker.defaults={maskInput:!1,pickDate:!0,pickTime:!0,pick12HourFormat:!1,pickSeconds:!0,startDate:-1/0,endDate:1/0,collapse:!0},t.fn.datetimepicker.Constructor=a;var n=0,o=t.fn.datetimepicker.dates={en:{days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"],daysShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sun"],daysMin:["Su","Mo","Tu","We","Th","Fr","Sa","Su"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],monthsShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]}},r={dd:{property:"UTCDate",getPattern:function(){return"(0?[1-9]|[1-2][0-9]|3[0-1])\\b"}},MM:{property:"UTCMonth",getPattern:function(){return"(0?[1-9]|1[0-2])\\b"}},yy:{property:"UTCYear",getPattern:function(){return"(\\d{2})\\b"}},yyyy:{property:"UTCFullYear",getPattern:function(){return"(\\d{4})\\b"}},hh:{property:"UTCHours",getPattern:function(){return"(0?[0-9]|1[0-9]|2[0-3])\\b"}},mm:{property:"UTCMinutes",getPattern:function(){return"(0?[0-9]|[1-5][0-9])\\b"}},ss:{property:"UTCSeconds",getPattern:function(){return"(0?[0-9]|[1-5][0-9])\\b"}},ms:{property:"UTCMilliseconds",getPattern:function(){return"([0-9]{1,3})\\b"}},HH:{property:"Hours12",getPattern:function(){return"(0?[1-9]|1[0-2])\\b"}},PP:{property:"Period12",getPattern:function(){return"(AM|PM|am|pm|Am|aM|Pm|pM)\\b"}}},h=[];for(var d in r)h.push(d);h[h.length-1]+="\\b",h.push(".");var c=new RegExp(h.join("\\b|"));h.pop();var l=new RegExp(h.join("\\b|"),"g"),p={modes:[{clsName:"days",navFnc:"UTCMonth",navStep:1},{clsName:"months",navFnc:"UTCFullYear",navStep:1},{clsName:"years",navFnc:"UTCFullYear",navStep:10}],isLeapYear:function(t){return t%4==0&&t%100!=0||t%400==0},getDaysInMonth:function(t,e){return[31,p.isLeapYear(t)?29:28,31,30,31,30,31,31,30,31,30,31][e]},headTemplate:'<thead><tr><th class="prev">&lsaquo;</th><th colspan="5" class="switch"></th><th class="next">&rsaquo;</th></tr></thead>',contTemplate:'<tbody><tr><td colspan="7"></td></tr></tbody>',getTemplate:function(t){return'<div class="datepicker-days"><table class="'+t+'">'+p.headTemplate+'<tbody></tbody></table></div><div class="datepicker-months"><table class="'+t+'">'+p.headTemplate+p.contTemplate+'</table></div><div class="datepicker-years"><table class="'+t+'">'+p.headTemplate+p.contTemplate+"</table></div>"}};p.template='<div class="datepicker-days"><table class="'+this.calendarTableClass+'">'+p.headTemplate+'<tbody></tbody></table></div><div class="datepicker-months"><table class="'+this.calendarTableClass+'">'+p.headTemplate+p.contTemplate+'</table></div><div class="datepicker-years"><table class="'+this.calendarTableClass+'">'+p.headTemplate+p.contTemplate+"</table></div>";var u={hourTemplate:'<span data-action="showHours" data-time-component="hours" class="timepicker-hour"></span>',minuteTemplate:'<span data-action="showMinutes" data-time-component="minutes" class="timepicker-minute"></span>',secondTemplate:'<span data-action="showSeconds" data-time-component="seconds" class="timepicker-second"></span>',getTemplate:function(t,e,i){return'<div class="timepicker-picker"><table class="'+i+'"'+(t?' data-hour-format="12"':"")+'><tr><td><a href="#" class="btn" data-action="incrementHours"><i class="icon-chevron-up"></i></a></td><td class="separator"></td><td><a href="#" class="btn" data-action="incrementMinutes"><i class="icon-chevron-up"></i></a></td>'+(e?'<td class="separator"></td><td><a href="#" class="btn" data-action="incrementSeconds"><i class="icon-chevron-up"></i></a></td>':"")+(t?'<td class="separator"></td>':"")+"</tr><tr><td>"+u.hourTemplate+'</td> <td class="separator">:</td><td>'+u.minuteTemplate+"</td> "+(e?'<td class="separator">:</td><td>'+u.secondTemplate+"</td>":"")+(t?'<td class="separator"></td><td><button type="button" class="btn btn-primary" data-action="togglePeriod"></button></td>':"")+'</tr><tr><td><a href="#" class="btn" data-action="decrementHours"><i class="icon-chevron-down"></i></a></td><td class="separator"></td><td><a href="#" class="btn" data-action="decrementMinutes"><i class="icon-chevron-down"></i></a></td>'+(e?'<td class="separator"></td><td><a href="#" class="btn" data-action="decrementSeconds"><i class="icon-chevron-down"></i></a></td>':"")+(t?'<td class="separator"></td>':"")+'</tr></table></div><div class="timepicker-hours" data-action="selectHour"><table class="'+i+'"></table></div><div class="timepicker-minutes" data-action="selectMinute"><table class="'+i+'"></table></div>'+(e?'<div class="timepicker-seconds" data-action="selectSecond"><table class="'+i+'"></table></div>':"")}}}(window.jQuery);